﻿/*
 * 作者: bcrun from xcstudy.com Copyright (c) 2010
 */
/*重要变化列表:
 * ★原来用canvas变量表示context型变量,现改为更合理的context
 * 
 * 
 */
/**
 * Copyright (c) 2009, Benjamin Joffe All rights reserved. Redistribution and
 * use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:
 *  * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer. * Redistributions in
 * binary form must reproduce the above copyright notice, this list of
 * conditions and the following disclaimer in the documentation and/or other
 * materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR
 * AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// (function(){
var map;
var canvas, context, cvsW, cvsH; // 主绘图区canvas的宽和高及其2d的context对象
var skyCanvas, skyContext;
var mapGridW = 5;

var floorCanvas, floorContext;
var overlay;
// variables initiated at the bottom of the code...

var pi = Math.PI;

var total = 0;

Number.prototype.range = function() {
	return (this + 2 * pi) % (2 * pi);
}
Number.prototype.roundC = function() {
	return Math.round(this * 100) / 100;
}

var total = 0;

var samples = 200;
var nWdSamples ;		//width / sampels

var arena = [];
//arena[0] = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
//arena[1] = [1, 0, 0, 0, 0, 0, 0, 0, 0, 1]
//arena[2] = [1, 0, 0, 1, 0, 1, 1, 1, 0, 1]
//arena[3] = [1, 0, 1, 0, 0, 0, 0, 1, 0, 1]
//arena[4] = [1, 0, 0, 0, 0, 1, 0, 1, 0, 1]
//arena[5] = [1, 0, 1, 1, 0, 0, 0, 0, 0, 1]
//arena[6] = [1, 0, 0, 1, 0, 1, 1, 1, 0, 1]
//arena[7] = [1, 1, 0, 1, 0, 0, 0, 1, 0, 1]
//arena[8] = [1, 0, 0, 1, 0, 1, 0, 0, 0, 1]
//arena[9] = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
arena[0] = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
arena[1] = [1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1]
arena[2] = [1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0, 1]
arena[3] = [1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 0,1, 1, 0, 1]
arena[4] = [1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1]
arena[5] = [1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1]
arena[6] = [1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1]
arena[7] = [1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1]
arena[8] = [1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1]
arena[9] = [1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1]
arena[10] = [1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1]
arena[11] = [1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1]
arena[12] = [1, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 1]
arena[13] = [1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1]
arena[14] = [1, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 2, 0, 0, 0, 1, 0, 1, 0, 1]
arena[15] = [1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1]
arena[16] = [1, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 1]
arena[17] = [1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 1]
arena[18] = [1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1]
arena[19] = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]

var playerPos = [1.2, 1.2]; // [4,4]; // x,y (from top left)
var playerDir = 0.6; // theta, facing right=0=2pi
var playerPosZ = 1;
var key = [0, 0, 0, 0, 0]; // left, right, up, down

var playerVelY = 0;

var face = [];

function wallDistance(theta) {
	// theta为视野左边界的角度
	var data = [];
	face = [];

	var x = playerPos[0], y = playerPos[1];
	var deltaX, deltaY;
	var distX, distY;
	var stepX, stepY;
	var mapX, mapY

	var atX = Math.floor(x), atY = Math.floor(y);

	var thisRow = -1; // this row
	var thisSide = -1;

	var lastHeight = 0;

	for (var i = 0; i < samples; i++) { // 对60度的视野等分成samples=200份计算?
		theta += pi / (3 * samples) + 2 * pi;
		theta %= 2 * pi;

		mapX = atX, mapY = atY;

		deltaX = 1 / Math.cos(theta);
		deltaY = 1 / Math.sin(theta);

		if (deltaX > 0) { // 面向偏右
			stepX = 1;
			distX = (mapX + 1 - x) * deltaX;
		} else { // 面向偏左
			stepX = -1;
			distX = (x - mapX) * (deltaX *= -1);
		}
		if (deltaY > 0) { // 面向偏下
			stepY = 1;
			distY = (mapY + 1 - y) * deltaY;
		} else { // 面向偏上
			stepY = -1;
			distY = (y - mapY) * (deltaY *= -1);
		}

		for (var j = 0; j < arena.length * 2; j++) {
			if (distX < distY) {
				mapX += stepX;
				if (mapX < 0) {
					if (i > 0) {
						if (lastHeight > 0) {
							data.push(i);
							data.push(lastHeight);
						}
					}
					lastHeight = 0;
					thisRow = mapX;
					break;
				}
				if (arena[mapX][mapY]) {
					if (thisRow != mapX || thisSide != 0) {// "不是同一条连续直线上的墙面"或者"不是一个方向的墙面"
						if (i > 0) {
							if (lastHeight > 0) {
								data.push(i);
								data.push(lastHeight);
							}
							// data.push(i);
							// data.push(lastHeight);
						}
						data.push(i);
						data.push(distX);
						thisSide = 0;
						thisRow = mapX;
						face.push(1 + stepX);
					}
					lastHeight = distX;
					break;
				}
				distX += deltaX;
			} else {
				mapY += stepY;
				if ((mapY < 0) || (mapY >= arena.length)) {
					if (i > 0) {
						if (lastHeight > 0) {
							data.push(i);
							data.push(lastHeight);
						}
					}
					lastHeight = 0;
					thisRow = mapY;
					break;
				}
				if (arena[mapX][mapY]) {
					if (thisRow != mapY || thisSide != 1) {
						if (i > 0) {
							if (lastHeight > 0) {
								data.push(i);
								data.push(lastHeight);
							}
							// data.push(i);
							// data.push(lastHeight);
						}
						data.push(i);
						data.push(distY);
						thisSide = 1;
						thisRow = mapY;
						face.push(2 + stepY)
					}
					lastHeight = distY;
					break;
				}
				distY += deltaY;
			}
		}
	}
	data.push(i);
	data.push(lastHeight);

	return data;
}

function drawCanvas() {
	var nGridW = mapGridW;
	var iCvsW = cvsW, iCvsH = cvsH;
	iHalfCvsH = iCvsH / 2;
	context.clearRect(0, 0, iCvsW, iCvsH);

	var theta = playerDir - pi / 6;

	var wall = wallDistance(theta);

	map.beginPath();
	map.clearRect(0, 0, 100, 100);
	map.fillStyle = "#3366CC";
	map.arc(playerPos[0] * nGridW, playerPos[1] * nGridW, 2, 0, 2 * pi, true);
	map.fill();// 画表示玩家位置的小圆点
	map.beginPath();
	map.moveTo(nGridW * playerPos[0], nGridW * playerPos[1]);

	var linGrad;

	var tl, tr, bl, br;

	var theta1, theta2, fix1, fix2;

	for (var i = 0; i < wall.length; i += 4) {

		theta1 = playerDir - pi / 6 + pi * wall[i] / (3 * samples);
		theta2 = playerDir - pi / 6 + pi * wall[i + 2] / (3 * samples);

		fix1 = Math.cos(theta1 - playerDir);
		fix2 = Math.cos(theta2 - playerDir);

		var h = 2 - playerPosZ;

		// var wallH1=100/(wall[i+1]*fix1);
		// var wallH2=100/(wall[i+3]*fix2);
		var wallH1 = (cvsH /3) / (wall[i + 1] * fix1);
		var wallH2 = (cvsH /3) / (wall[i + 3] * fix2);

		tl = [wall[i] * nWdSamples, iHalfCvsH - wallH1 * h];
		tr = [wall[i + 2] * nWdSamples, iHalfCvsH - wallH2 * h]
		br = [wall[i + 2] * nWdSamples, tr[1] + wallH2 * 2];
		bl = [wall[i] * nWdSamples, tl[1] + wallH1 * 2]

		var shade1 = Math.floor(wallH1 * 2 + 20);
		if (shade1 > 255)
			shade1 = 255;
		var shade2 = Math.floor(wallH2 * 2 + 20);
		if (shade2 > 255)
			shade2 = 255;

		linGrad = context.createLinearGradient(tl[0], 0, tr[0], 0);
		linGrad.addColorStop(0, 'rgba(' + (face[i / 4] % 2 == 0 ? shade1 : 0)
						+ ',' + (face[i / 4] == 1 ? shade1 : 0) + ','
						+ (face[i / 4] == 2 ? 0 : shade1) + ',1.0)');
		linGrad.addColorStop(1, 'rgba(' + (face[i / 4] % 2 == 0 ? shade2 : 0)
						+ ',' + (face[i / 4] == 1 ? shade2 : 0) + ','
						+ (face[i / 4] == 2 ? 0 : shade2) + ',1.0)');

		context.beginPath();
		context.moveTo(tl[0], tl[1]);
		context.lineTo(tr[0], tr[1]);
		context.lineTo(br[0], br[1]);
		context.lineTo(bl[0], bl[1]);
		context.fillStyle = linGrad;
		context.fill();

		map.lineTo(playerPos[0] * nGridW + Math.cos(theta1) * (wall[i + 1]) * nGridW,
				playerPos[1] * nGridW + Math.sin(theta1) * (wall[i + 1]) * nGridW);
		map.lineTo(playerPos[0] * nGridW + Math.cos(theta2) * (wall[i + 3]) * nGridW,
				playerPos[1] * nGridW + Math.sin(theta2) * (wall[i + 3]) * nGridW);

	}
	// 如只是这样简单的画个"等腰三角形"的视野范围不如上面画出多边形的实际视野范围更好
	// map.lineTo(playerPos[0]*8+Math.cos(playerDir-pi/6)*8*8,
	// playerPos[1]*8+Math.sin(playerDir-pi/6)*8*8);
	// map.lineTo(playerPos[0]*8+Math.cos(playerDir+pi/6)*8*8,
	// playerPos[1]*8+Math.sin(playerDir+pi/6)*8*8);
	map.fillStyle = "#FF0000"
	map.fill();

}

function nearWall(x, y) {
	var xx, yy;
	if (isNaN(x))
		x = playerPos[0];
	if (isNaN(y))
		y = playerPos[1];
	for (var i = -0.1; i <= 0.1; i += 0.2) {
		xx = Math.floor(x + i)
		for (var j = -0.1; j <= 0.1; j += 0.2) {
			yy = Math.floor(y + j);
			if (arena[xx][yy])
				return true;
		}
	}
	return false;
}

var xOff = 0;
var yOff = 0;
function wobbleGun() {
	var mag = playerVelY;
	xOff = (10 + Math.cos(total / 6.23) * mag * 90)
	yOff = (10 + Math.cos(total / 5) * mag * 90)
	overlay.style.backgroundPosition = xOff + "px " + yOff + "px";
	var sx=0,sy=0,sw=400,sh=300;
	var dw=cvsW, dh=cvsH;
	context.drawImage(document.getElementById("imgOverlay"), sx, sy, sw, sh, 0, 0, dw, dh);
	
}

var jumpCycle = 0;

//var audio = window.Audio && new Audio("shoot.wav");
var audio; 

function shoot() {
	audio && audio.play();
	context.save();
	context.strokeStyle = "#FFFF00";
	context.beginPath();
	
	var cx = 190 * (cvsW / 400),cy = 140 * (cvsH / 300)
	var cx2 = 250 * (cvsW / 400),cy2 = 200 * (cvsH / 300)
	context.moveTo(cx + xOff, cy + yOff);
	context.lineTo(cx2 + xOff, cy2 + yOff);
	context.closePath();
	context.stroke();
	context.restore();
	setTimeout('drawCanvas()', 100);
}

function drawSky() {
	// document.getElementById("sky").style.backgroundPosition=Math.floor(1-playerDir/(2*pi)*2400)+"px
	// 0";
	var iX = (Math.floor(playerDir / (2 * pi) * 2400) + 2400) % 2400;
	var iSIWidth = 2400,iSIHeight = 150;	//源360度全景图片宽度
	var iSRWidth = iSIWidth / 6; // 图片源矩形区的宽度,注意,取6是因为全景360度是视野60度的6倍
	var sx, sy, sw, sh, dx, dy, dw, dh;
	// 注意这个位置坐标要按"矢量绘图"计算,别按传统的GDI点阵图坐标计算,举例,横向左起第一个点,是x坐标0与1间的点,而不是象处理点阵那样就是对应着坐标0
	if (iX + iSRWidth >= iSIWidth) {
		var iPart1W = (iSIWidth - iX - 1);
		dw = iPart1W * (cvsW / iSRWidth);
		dh = cvsH/2;
		skyContext.drawImage(document.getElementById("imgSky"), iX, 0, iPart1W,
				iSIHeight, 0, 0, dw, dh);
		var iPart2W = iX + iSRWidth - iSIWidth + 1;
		sw = iPart2W;
		sh = iSIHeight;
		dx = (iSIWidth - iX) * (cvsW / iSRWidth) - 2;
		dy = 0;
		skyContext.drawImage(document.getElementById("imgSky"), 0, 0, sw, sh,
				dx, dy, iPart2W * (cvsW / iSRWidth), cvsH/2);

	} else {
		skyContext.drawImage(document.getElementById("imgSky"), iX, 0, iSRWidth,
				iSIHeight, 0, 0, cvsW, cvsH/2);

	}
}

function update() {

	total++;

	var change = false;

	if (jumpCycle) {
		jumpCycle--;
		change = true;
		playerPosZ = 1 + jumpCycle * (20 - jumpCycle) / 110;
	} else if (key[4])
		jumpCycle = 20;

	if (key[0]) {
		if (!key[1]) {
			playerDir -= 0.07; // left
			change = true;
		}
	} else if (key[1]) {
		playerDir += 0.07; // right
		change = true;
	}

	if (change) {
		playerDir += 2 * pi;
		playerDir %= 2 * pi;
		drawSky();
	}

	if (key[2] && !key[3]) {
		if (playerVelY < 0.1)
			playerVelY += 0.02;
	} else if (key[3] && !key[2]) {
		if (playerVelY > -0.1)
			playerVelY -= 0.02;
	} else {
		if (playerVelY < -0.02)
			playerVelY += 0.015;
		else if (playerVelY > 0.02)
			playerVelY -= 0.015;
		else
			playerVelY = 0;
	}

	if (playerVelY != 0) {

		var oldX = playerPos[0];;
		var oldY = playerPos[1];
		var newX = oldX + Math.cos(playerDir) * playerVelY;
		var newY = oldY + Math.sin(playerDir) * playerVelY;

		if (!nearWall(newX, oldY)) {
			playerPos[0] = newX;
			oldX = newX;
			change = true;
		}
		if (!nearWall(oldX, newY)) {
			playerPos[1] = newY;
			change = true;
		}

	}

	if (change)
		drawCanvas();
	//if (playerVelY)
		wobbleGun();

}

function changeKey(which, to) {
	switch (which) {
		case 65 :
		case 37 :
			key[0] = to;
			break; // left
		case 87 :
		case 38 :
			key[2] = to;
			break; // up
		case 68 :
		case 39 :
			key[1] = to;
			break; // right
		case 83 :
		case 40 :
			key[3] = to;
			break;// down
		case 32 :
			key[4] = to;
			break; // space bar;
		case 17 :
			key[5] = to;
			break; // ctrl
		case 66 :
			if (to) {
				shoot()
			}
			break; // b
	}
}
document.onkeydown = function(e) {
	changeKey((e || window.event).keyCode, 1);
}
document.onkeyup = function(e) {
	changeKey((e || window.event).keyCode, 0);
}

function initUnderMap() {
	var underMap = document.getElementById("underMap").getContext("2d");
	var nGridW = mapGridW;
	// underMap.fillStyle="#FFF";
	// underMap.fillRect(0,0, 200, 200);
	underMap.fillStyle = "#444";
	for (var i = 0; i < arena.length; i++) {
		for (var j = 0; j < arena[i].length; j++) {
			if (arena[i][j])
				underMap.fillRect(i * nGridW, j * nGridW, nGridW, nGridW);
		}
	}
}

window.onload = function() {
	audio = document.getElementById("audio");
	var ele = document.getElementById("map");
	if (!ele.getContext) {
		alert('An error occured creating a Canvas 2D context. This may be because you are using an old browser, if not please contact me and I\'ll see if I can fix the error.');
		return;
	}
	map = ele.getContext("2d");
	canvas = document.getElementById("canvas");
	context = canvas.getContext("2d");
	cvsW = canvas.width;
	cvsH = canvas.height;
	overlay = document.getElementById("overlay");
	skyContext = (skyCanvas = document.getElementById("skyCanvas")).getContext("2d");
	floorCanvas = document.getElementById("floorCanvas");
	floorContext = floorCanvas.getContext("2d");
	changeCanvasRect(cvsW, cvsH);
	changeCanvasRect(800, 480);
	drawSky();

	drawCanvas();
	initUnderMap();
	setInterval(update, 35);
}

/*
 * 更新一组canvas尺寸
 */
function changeCanvasRect(newW, newH) {
	cvsW = newW;
	cvsH = newH;
	nWdSamples = newW / samples;
	var holder = document.getElementById("holder");
	holder.style.width = newW + 'px';
	holder.style.height = newH + 'px';
	
	canvas.width = newW;
	canvas.height = newH;
	canvas.style.width = newW + 'px';
	canvas.style.height = newH + 'px';
	
	skyCanvas.width = newW;
	skyCanvas.height = newH / 2;
	skyCanvas.style.width = newW + 'px';
	skyCanvas.style.height = newH /2  + 'px';
	
	floorCanvas.style.left = "0px";
	floorCanvas.style.top =  newH /2  + 'px';
	floorCanvas.width = newW;
	floorCanvas.height = newH / 2;
	floorCanvas.style.width = newW + 'px';
	floorCanvas.style.height = newH /2  + 'px';
	


	var linGrad = floorContext.createLinearGradient(newW/2, 0, newW/2, newH /2-1);
	linGrad.addColorStop(0, 'rgba(35,52,35,1.0)');
	linGrad.addColorStop(1, 'rgba(152,152,152,1.0)');
	floorContext.fillStyle = linGrad;
	floorContext.fillRect(0, 0, newW, newH /2);

}

	// })();

